package com.aheaditec.freerasp

import android.content.Context
import androidx.annotation.NonNull
import com.aheaditec.flutter.freerasp_release.flutter_freerasp_release.TalsecApp

import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.EventChannel
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result

/** FreeraspPlugin */
class FreeraspPlugin: FlutterPlugin, MethodCallHandler {
  private lateinit var configChannel: MethodChannel
  private lateinit var eventChannel: EventChannel
  private lateinit var context: Context

  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    context = flutterPluginBinding.applicationContext
    eventChannel = EventChannel(flutterPluginBinding.binaryMessenger, "plugins.aheaditec.com/events")
    configChannel = MethodChannel(flutterPluginBinding.binaryMessenger, "plugins.aheaditec.com/config")
    configChannel.setMethodCallHandler(this)
  }

  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
    if (call.method == "getConfig") {
      val epn = call.argument<String>("expectedPackageName")!!
      val esch = call.argument<String>("expectedSigningCertificateHash")!!
      val wm = call.argument<String>("watcherMail")!!
      val sas = call.argument<List<String>>("supportedAlternativeStores")!!
      setupHandler(epn, esch, wm, sas)
    } else {
      result.notImplemented()
    }
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
    configChannel.setMethodCallHandler(null)
  }

  private fun setupHandler(epn: String, esch: String, wm: String, sas: List<String>) {
    eventChannel.setStreamHandler(
      object : EventChannel.StreamHandler {

        override fun onListen(arguments: Any?, events: EventChannel.EventSink) {
          TalsecApp(epn, esch, wm, sas.toTypedArray(), context, events)
        }

        override fun onCancel(arguments: Any?) {
          TODO("Not yet implemented")
        }
      }
    )
  }
}
