package com.aheaditec.flutter.freerasp_release.flutter_freerasp_release

import android.content.Context
import android.util.Log
import com.aheaditec.talsec_security.security.api.Talsec
import com.aheaditec.talsec_security.security.api.TalsecConfig
import com.aheaditec.talsec_security.security.api.ThreatListener
import io.flutter.plugin.common.EventChannel

class TalsecApp(
    expectedPackageName: String,
    expectedSigningCertificateHash: String,
    watcherMail: String,
    supportedAlternativeStores: Array<String>,
    context: Context,
    private val event: EventChannel.EventSink
) : ThreatListener.ThreatDetected {

    init {
        val config = TalsecConfig(
            expectedPackageName,
            expectedSigningCertificateHash,
            watcherMail,
            supportedAlternativeStores
        )
        ThreatListener(this).registerListener(context)
        Talsec.start(context, config)
    }

    override fun onRootDetected() {
        event.success("onRootDetected")
    }

    override fun onDebuggerDetected() {
        event.success("onDebuggerDetected")
    }

    override fun onEmulatorDetected() {
        event.success("onEmulatorDetected")
    }

    override fun onTamperDetected() {
        event.success("onTamperDetected")
    }

    override fun onHookDetected() {
        event.success("onHookDetected")
    }

    override fun onFingerprintDetected() {
        event.success("onFingerprintDetected")
    }

}