import 'package:flutter/foundation.dart';

/// Model class for Android callbacks.
///
/// Callbacks (pointers) are called in talsec_config.
class AndroidCallback {
  /// Callback called when device is rooted
  final VoidCallback? onRootDetected;

  /// Callback called when app is running on emulator
  final VoidCallback? onEmulatorDetected;

  /// Callback called when app code integrity is disturbed
  final VoidCallback? onTamperDetected;

  /// Callback called when hooking framework is present or used
  final VoidCallback? onHookDetected;

  /// Callback alled when fingerprint is disturbed
  final VoidCallback? onFingerprintDetected;

  AndroidCallback(
      {this.onRootDetected,
      this.onEmulatorDetected,
      this.onTamperDetected,
      this.onHookDetected,
      this.onFingerprintDetected});
}
