import 'android/android_config.dart';
import 'ios/ios_config.dart';

export 'android/android_config.dart';
export 'ios/ios_config.dart';

/// Wrapper for configuration objects.
///
/// Holds [androidConfig] and [IOSConfig] as parameters and wraps them into
/// general [TalsecConfig].
/// Also contains [watcherMail] for alerts and reports.
class TalsecConfig {
  final AndroidConfig? androidConfig;
  final IOSconfig? IOSConfig;
  final String watcherMail;

  TalsecConfig({this.androidConfig, this.IOSConfig, this.watcherMail = ''});
}
